
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
//import java.io.PrintStream;
import java.util.StringTokenizer;
import java.util.*;

public class arbitrage {

    public static void main(String args[]) throws IOException {

        BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
        int number = Integer.parseInt(in.readLine());
                      
        while(number != 0){
        
			String line = in.readLine();
			StringTokenizer tokenizer2 = new StringTokenizer(line, " "); 
			
			Hashtable<String, Double> table = new Hashtable<String, Double>();
		   
			for(int i=0; i < number; i++){
				table.put(tokenizer2.nextToken(), -1.0);
			}
			
			int transnumber = Integer.parseInt(in.readLine());
			
			boolean endflag = false;
			
			for(int i=0; i < transnumber; i++){
				String line2 = in.readLine();
				StringTokenizer tokenizer = new StringTokenizer(line2, " ");
				
				String cur1 = tokenizer.nextToken();
				String cur2 = tokenizer.nextToken();
				String conv = tokenizer.nextToken();
				
				if((table.get(cur1) == -1.0) && (table.get(cur2) == -1.0)){
					StringTokenizer transTokenizer = new StringTokenizer(conv, ":");
					table.put(cur1, Double.parseDouble(transTokenizer.nextToken()));
					table.put(cur2, Double.parseDouble(transTokenizer.nextToken()));
				}
				else if((table.get(cur1) != -1) && (table.get(cur2) != -1)){
					StringTokenizer transTokenizer = new StringTokenizer(conv, ":");
					Double newNum1 = Double.parseDouble(transTokenizer.nextToken());
					Double newNum2 = Double.parseDouble(transTokenizer.nextToken());
					if(table.get(cur1)/table.get(cur2) != newNum1/newNum2) 
						endflag = true;
				}
				else{
					StringTokenizer transTokenizer = new StringTokenizer(conv, ":");
					Double newNum1 = Double.parseDouble(transTokenizer.nextToken());
					Double newNum2 = Double.parseDouble(transTokenizer.nextToken());
					if(table.get(cur1) == -1)
						table.put(cur1,(table.get(cur2)*newNum1/newNum2)); 
					else
						table.put(cur2,(table.get(cur1)*newNum2/newNum1));
				}
			}
			
			if(endflag)
				System.out.println("Arbitrage");
			else
				System.out.println("Ok");
			
			number = Integer.parseInt(in.readLine());
        	
			}
			
		}

    }
