
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.StringTokenizer;
import java.util.*;

public class arbitrage2 {

    public static void main(String args[]) throws IOException {

        BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
        int number = Integer.parseInt(in.readLine());
                      
        while(number != 0){
        
			String line = in.readLine();
			StringTokenizer tokenizer2 = new StringTokenizer(line, " "); 
			
			Hashtable<String, Double> table = new Hashtable<String, Double>();
		   	
		   	String[] curs = new String[number];
		   
			for(int i=0; i < number; i++){
				String currency = tokenizer2.nextToken();
				
				table.put(currency, -1.0);
				
				curs[i] = currency;
			}
			
			double[][] values = new double[number][number];
			
			int transnumber = Integer.parseInt(in.readLine());
			
			boolean endflag = false;
			
			for(int i=0; i < transnumber; i++){
				String line2 = in.readLine();
				StringTokenizer tokenizer = new StringTokenizer(line2, " ");
				
				String cur1 = tokenizer.nextToken();
				String cur2 = tokenizer.nextToken();
				String conv = tokenizer.nextToken();
				
				if((table.get(cur1) == -1.0) && (table.get(cur2) == -1.0)){
					StringTokenizer transTokenizer = new StringTokenizer(conv, ":");
					String num1 = transTokenizer.nextToken();
					String num2 = transTokenizer.nextToken();
					table.put(cur1, Double.parseDouble(num1));
					table.put(cur2, Double.parseDouble(num2));
					
					for(int j=0; j<number; j++){
						if(curs[j].equals(cur1)){
							for(int h=0; h<number; h++){
								if(curs[h].equals(cur2)){
									values[j][h] = Double.parseDouble(num1)/Double.parseDouble(num2);
									values[h][j] = Double.parseDouble(num2)/Double.parseDouble(num1);
								}
							}
						}
					}
					
				}
				else if((table.get(cur1) != -1) && (table.get(cur2) != -1)){
					StringTokenizer transTokenizer = new StringTokenizer(conv, ":");
					Double newNum1 = Double.parseDouble(transTokenizer.nextToken());
					Double newNum2 = Double.parseDouble(transTokenizer.nextToken());
					for(int j=0; j<number; j++){
						if(curs[j].equals(cur1)){
							for(int h=0; h<number; h++){
								if(curs[h].equals(cur2)){
									if(values[j][h] != newNum1/newNum2 && values[j][h] != 0)
										endflag = true;
								}
							}
						}
					}
				}
				else{
					StringTokenizer transTokenizer = new StringTokenizer(conv, ":");
					Double newNum1 = Double.parseDouble(transTokenizer.nextToken());
					Double newNum2 = Double.parseDouble(transTokenizer.nextToken());
					if(table.get(cur1) == -1){
						table.put(cur1,(table.get(cur2)*newNum1/newNum2));
						for(int j=0; j<number; j++){
						if(curs[j].equals(cur1)){
							for(int h=0; h<number; h++){
								if(curs[h].equals(cur2)){
									if(values[j][h] != newNum1/newNum2 && values[j][h] != 0)
										endflag = true;
									else
										values[j][h] = newNum1/newNum2;
										
									if(values[h][j] != newNum2/newNum1 && values[h][j] != 0)
										endflag = true;
									else
										values[h][j] = newNum2/newNum1;
									}
							}
						}
					}
				} 
					else{
						table.put(cur2,(table.get(cur1)*newNum2/newNum1));
						for(int j=0; j<number; j++){
						if(curs[j].equals(cur1)){
							for(int h=0; h<number; h++){
								if(curs[h].equals(cur2)){
									values[j][h] = newNum1/newNum2;
									values[h][j] = newNum2/newNum1;
								}
							}
						}
					}
				}
				}
			}
			
			if(endflag)
				System.out.println("Arbitrage");
			else
				System.out.println("Ok");
			
			number = Integer.parseInt(in.readLine());
        	
			}
			
		}

    }
